{mik  7/5/98 }
unit Mchklist;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls,
     Forms, Graphics, Stdctrls;

type
  TChkListBox = class(TCustomListBox)
    private
        FBitmap : Tbitmap;
        mlist : Tstringlist;
        procedure AutoInitialize;
        procedure AutoDestroy;
        Procedure setItem;
        Procedure setItems(value : Tstrings);
        function ischecked(index:integer):boolean;
        Procedure setcheck(index: integer;value : boolean);
        procedure setmulti(value:boolean);
    protected
        Procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
        procedure DrawCheckBox( Index : Integer ; State: TOwnerDrawState );
        procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
        procedure clear;
    public
        Selection : string;
        procedure showchecked;
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
      	property Selected[ Index : Integer ] : Boolean read IsChecked write Setcheck;
        property Multi: boolean write setmulti;
    published
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property OnKeyUp;
        property OnKeyDown;
        property OnKeyPress;
        property Font;
        property Items write SetItems;
  end;

procedure Register;

implementation

procedure Register;
begin
 RegisterComponents('Samples', [TChkListBox]);
end;

Procedure TChkListBox.clear;
begin
 items.clear;
 mlist.clear;
 selection := '';
end;

Procedure TChkListBox.setmulti(value:boolean);
begin
  multiselect := value;
end;

Procedure TChkListBox.setcheck(index: integer; value : boolean);
begin
  if (mlist.count > index) then
  if selected[index] <> value then
   begin
   if value then
      mlist[index] := '1'
   else
     mlist[index] := '0';
   invalidate;
   end;
end;

function TChkListBox.ischecked(index:integer):boolean;
begin
result := false;
 if (mlist.count > index) then
  result := mlist[index]= '1';
end;

procedure TChkListBox.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
inherited mouseup(Button, Shift, X, Y);
if x <= 16 then
 if mlist.count > 0 then
  begin
   if mlist[itemindex] = '0' then
      mlist[itemindex] := '1'
   else
      mlist[itemindex] := '0';
  end;
 invalidate;
end;


procedure TChkListBox.Setitem;
var i : integer;
begin
 mlist.clear;
 if items.count > 0 then
   for i := 0 to items.count -1 do
    mlist.add('0');
 showchecked;
end;

procedure TChkListBox.Setitems(value : Tstrings);
begin
 items.assign(value);
 mlist.clear;
 refresh;
end;

procedure TChkListBox. showchecked;
var i : integer;
begin
 if length(selection) > 0 then
   for i := 1 to length(selection) do
     selected[byte(selection[i])] := true;
end;

procedure TChkListBox.AutoInitialize;
begin
   mlist := Tstringlist.create;
   Fbitmap := Tbitmap.create;
   Style := lbOwnerDrawvariable;
   multiselect := true;
   Fbitmap.Handle := LoadBitmap( 0 , PChar( OBM_CHECKBOXES ) );
   itemheight := 22;
   selection := '';
end;

procedure TChkListBox.AutoDestroy;
begin
   mlist.free;
   Fbitmap.free;
end;

procedure TChkListBox.DrawCheckBox(Index : Integer ; State: TOwnerDrawState );
const
 CheckBoxWidth = 12;
var
	ARect : TRect;
begin
	ARect := ItemRect( Index );
 with ARect do
 	begin
   	Inc( Left , 2 );
     Inc( Top , 2 );
     Right := Left + CheckBoxWidth + 2;
     Bottom := Top + CheckBoxWidth + 2;
   end;

	with Canvas do
 	begin
     if ( odSelected in State ) then
       CopyMode := cmNotSrcCopy
     else
       CopyMode := cmSrcCopy;

     if (mlist.count > Index) and ( Mlist[ Index ] = '1' ) then
				CopyRect( ARect , Fbitmap.Canvas , Rect(12,0,24,12))
			else
				CopyRect( ARect , Fbitmap.Canvas , Rect(0,0,12,12));
   end;
end;


procedure TChkListBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Offset: Integer;
begin
 if items.count = 0 then exit;
 if mlist.count = 0 then
   setitem;
  with Canvas do
  begin
   FillRect(Rect);
   Offset := 2;
   brush.color := clwhite;
   if multiselect then
   begin
    DrawCheckBox(Index, State);
    Offset := 12 + 8;
   end
   else
    Offset :=  2;
   brush.color := clblack;
   brush.style := bsclear;
   TextOut(Rect.Left + Offset, Rect.Top, items[index]);
   brush.style := bsSOLID;
  end;
end;


constructor TChkListBox.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
end;

destructor TChkListBox.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

end.
