{7/05/98 by Mik}
unit MOpenDlg;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls,
     Forms, Graphics, Dialogs, opendlg;
type
  TMOpenDialog = class(Tcomponent)
  private
    FFileName: TFileName;
    FFileExt : TFileExt;
    Finidir : string;
    Findex : Integer;
    Ftitle :string;
    FFilter: String;
    Fmulti : Boolean;
  public
    Selected : string;
    Files: Tstringlist ;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
  published
    property MultiFiles : Boolean read Fmulti write Fmulti;
    property DefaultExt: TFileExt read FFileExt write FFileExt;
    property FileName: TFileName read FFileName write FFileName;
    property Filter: string read FFilter write FFilter;
    property FilterIndex: Integer read Findex write Findex;
    property InitialDir: string read Finidir write Finidir;
    property Title: string read Ftitle write Ftitle;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Dialogs', [TMOpenDialog]);
end;

constructor TMOpenDialog.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     Files:= TStringlist.create;
     Fmulti := true;
     selected := '';
end;

destructor TMOpenDialog.Destroy;
begin
     Files.free;
     inherited Destroy;
end;

function TMOpenDialog.execute;
var i : integer;
begin
MultiOpendialog:= TMultiOpendialog.create(nil);
with MultiOpendialog do
 begin
  ChkListBox1.multi := Fmulti;
  if Ftitle <> '' then
   Caption := Ftitle;
  if Ffilename <> '' then
   begin
    edit1.text := Ffilename;
    if pos('.*',Ffilename) > 0  then
     begin
      FilterComboBox1.itemindex := 2;
      FileListBox1.mask := Ffilename;
     end;
   end
  else
   IF FFileExt <> '' THEN
   edit1.text := '*.' + FFileExt;
  DirectoryListBox1.directory := InitialDir;
  case length(selected) of
   1: selection := '';
   else
     selection := selected;
  end;
  i:= showmodal;
  Result := re = 1;
 if result then
  begin
  files.clear;
  selected := '';
   if edit1.text <> '' then
    begin
    if label3.caption[length(label3.caption)] = '\' then
     filename := label3.caption + edit1.text
    else
     filename := label3.caption + '\' + edit1.text;
    end;
  if ChkListBox1.items.count > 0 then
   begin
   for i := 0 to ChkListBox1.items.count - 1 do
    if ChkListBox1.selected[i] then
     begin
      files.add(ChkListBox1.items[i]);
      selected := selected + char(i);
     end;
    if length(selected) = 1 then selected := '';
   end;
  end;
 end;
end;

end.
